import { ErrorObject } from 'ajv';
import { Schema } from './util/schema.types';
declare type MessageFactory = (dataPath: string, params: Record<string, unknown>, schema: Schema) => string;
declare const staticMessageKeys: readonly ["fallback", "rootRequired"];
export declare type BuiltInErrorMessages = {
    static: Record<typeof staticMessageKeys[number], string>;
    keyword: Record<string, MessageFactory>;
};
export declare class ValidationError extends Error {
    constructor(errors: ErrorObject[] | undefined | null);
}
export declare function setLocaleMessages(messages: BuiltInErrorMessages): void;
export declare function setStaticMessage(key: typeof staticMessageKeys[number], message: string): void;
export declare function setKeywordMessage(key: string, messageFactory: MessageFactory): void;
export {};
