import { ArrayShape, Shape, ShapeValue, TupleShape } from '../util/shape.types';
declare type TupleShapeValue<ST> = {
    [P in keyof ST]: ShapeValue<ST[P]>;
};
/**
 * 创建一个「形状」用于描述数组，数组的元素可以是另一个「形状」的值
 * @param itemShape 描述数组元素的「形状」
 */
export declare function array<T extends Shape>(itemShape: T): ArrayShape<ShapeValue<T>[]>;
/**
 * 创建一个「形状」用于描述元组，元组的每个位置的「形状」按照参数顺序定义
 * @param itemShapes 元组每个元素的「形状」，按照元组元素的顺序和个数定义即可
 */
export declare function tuple<T extends Shape[]>(...itemShapes: T): TupleShape<TupleShapeValue<T>>;
export {};
