"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.string = void 0;
const base_1 = require("./base");
class StringShapeImpl extends base_1.BaseShapeImpl {
    constructor(schema, options) {
        super(schema, options);
    }
    minLength(length) {
        return this.produce_((draft) => {
            draft.minLength = length;
        }, undefined);
    }
    maxLength(length) {
        return this.produce_((draft) => {
            draft.maxLength = length;
        }, undefined);
    }
    pattern(pattern) {
        const { source, flags } = pattern;
        if (!flags) {
            return this.produce_((draft) => {
                draft.pattern = source;
            }, undefined);
        }
        return this.produce_((draft) => {
            draft.regexp = { pattern: source, flags };
        }, undefined);
    }
    format(format) {
        return this.produce_((draft) => {
            draft.format = format;
        }, undefined);
    }
    trim() {
        return this.before({ transform: ['trim'] }, true);
    }
    lowercase() {
        return this.before({ transform: ['toLowerCase'] }, true);
    }
    uppercase() {
        return this.before({ transform: ['toUpperCase'] }, true);
    }
}
/**
 * 创建一个「形状」用于描述字符串值
 */
function string() {
    return new StringShapeImpl({ type: 'string' });
}
exports.string = string;
